// DialogEditQuotes.cpp : implementation file
//

#include "stdafx.h"
#include "SigCtrl.h"
#include "DialogEditQuotes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogEditQuotes dialog


CDialogEditQuotes::CDialogEditQuotes(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogEditQuotes::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogEditQuotes)
	//}}AFX_DATA_INIT

  m_nMinHeight = 0;
  m_nMinWidth = 0;
}

CDialogEditQuotes::~CDialogEditQuotes () {
    /* destroy all data in the quotes list that might have been 
       allocated earlier */
    while (! m_quote_list.IsEmpty()) {
        CString * quote = (CString *)m_quote_list.RemoveHead ();
        delete quote;
    }
}

void CDialogEditQuotes::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogEditQuotes)
	DDX_Control(pDX, IDC_LIST_QUTOES, m_ListQuotes);
	DDX_Control(pDX, IDC_EDIT_NEW, m_EditNewQuote);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogEditQuotes, CDialog)
	//{{AFX_MSG_MAP(CDialogEditQuotes)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_QUOTE, OnButtonEditQuote)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogEditQuotes message handlers

void CDialogEditQuotes::OnButtonAdd() 
{
    CString quote;
    m_EditNewQuote.GetWindowText (quote);
    m_ListQuotes.AddString (quote);
    m_EditNewQuote.SetWindowText ("");
}

void CDialogEditQuotes::OnButtonRemove() 
{
    int index = m_ListQuotes.GetCurSel();
    if (index != LB_ERR) {
        m_ListQuotes.DeleteString (index);
    }
}

void CDialogEditQuotes::OnButtonEditQuote() 
{
    int index = m_ListQuotes.GetCurSel ();
    if (index != LB_ERR) {
        CString quote;
        m_ListQuotes.GetText( index, quote);
        m_EditNewQuote.SetWindowText (quote);
    }
}

void CDialogEditQuotes::OnOK() 
{
    int count = m_ListQuotes.GetCount ();
    CString *quote = NULL;

    /* destroy all data in the quotes list that might have been 
       allocated earlier */
    quote = NULL;
    while (! m_quote_list.IsEmpty()) {
        quote = (CString *)m_quote_list.RemoveHead ();
        delete quote;
    }

    /* copy contents of control type list into the variable type list, 
        so that it can be accessed after the window is destroyed */
    for (int i = 0; i < count; i++) {
        quote = new CString;
        m_ListQuotes.GetText (i, *quote);
        m_quote_list.AddTail (quote);
    }
    
	CDialog::OnOK();
}

BOOL CDialogEditQuotes::OnInitDialog() 
{
  CDialog::OnInitDialog();

  // Save the default size of the dialog, so that it can not resize to less than this
  RECT size;
  GetWindowRect (&size);
  m_nMinWidth = size.right - size.left;
  m_nMinHeight = size.bottom - size.top;
  
  /* copy contents of the variable type list into the control type list */
  POSITION pos = m_quote_list.GetHeadPosition ();
  CString *quote = NULL;
  while (pos != NULL) {
    quote = (CString *)m_quote_list.GetNext(pos);
    m_ListQuotes.AddString (*quote);
  }
  
  return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDialogEditQuotes::OnSize(UINT nType, int cx, int cy) 
{
  if (cx < m_nMinWidth || cy < m_nMinHeight)
  {
    RECT size;
    GetWindowRect (&size);
    size.right = size.left + m_nMinWidth;
    size.bottom = size.top + m_nMinHeight;

    MoveWindow (&size);
  }
  else
  {
	  CDialog::OnSize(nType, cx, cy);


  }
}
