// SigCtrlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SigCtrl.h"
#include "SigCtrlDlg.h"
#include "DialogEditQuotes.h"
#include "DialogEditFile.h"

// include file stream header
#include <fstream.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigCtrlDlg dialog

CSigCtrlDlg::CSigCtrlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSigCtrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSigCtrlDlg)
	m_TempDay = 0;
	m_TempHour = 0;
	m_TempMinute = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_source_filepath = "";
    m_sig_filepath = "";
    m_nDay = 0;
    m_nMinute = 0;
    m_nHour = 0;
    m_bStartupChange = FALSE;
    m_bStartupOpen = TRUE;
    m_bStartupRun = FALSE;
    m_bTaskbarIcon = TRUE;
    m_bChangeTimer = FALSE;
}

void CSigCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSigCtrlDlg)
	DDX_Control(pDX, IDC_ButtonSigFileEdit, m_ButtonSigEdit);
	DDX_Control(pDX, IDC_CHECK_STARTUPRUN, m_CheckStartupRun);
	DDX_Control(pDX, IDC_CHECK_STARTUPOPEN, m_CheckStartupOpen);
	DDX_Control(pDX, IDC_CHECK_STARTUPCHANGE, m_CheckStartupChange);
	DDX_Control(pDX, IDCANCEL, m_CancelButtonCtrl);
	DDX_Control(pDX, IDOK, m_OKButtonCtrl);
	DDX_Control(pDX, IDC_CHECK_TIMER, m_CheckTimer);
	DDX_Control(pDX, IDC_CHECK_TASKBAR, m_CheckTaskbar);
	DDX_Control(pDX, IDC_STATIC_MINUTE, m_StaticMinute);
	DDX_Control(pDX, IDC_STATIC_HOUR, m_StaticHour);
	DDX_Control(pDX, IDC_STATIC_DAY, m_StaticDay);
	DDX_Control(pDX, IDC_EDIT_MINUTE, m_EditMinute);
	DDX_Control(pDX, IDC_EDIT_HOUR, m_EditHour);
	DDX_Control(pDX, IDC_EDIT_DAY, m_EditDay);
	DDX_Control(pDX, IDC_EDIT_SOURCEFILE, m_EditSourceFile);
	DDX_Control(pDX, IDC_EDIT_SIG_FILE, m_EditSigFile);
	DDX_Control(pDX, IDC_ButtonSourceFileEdit, m_ButtonSourceEdit);
	DDX_Text(pDX, IDC_EDIT_DAY, m_TempDay);
	DDV_MinMaxInt(pDX, m_TempDay, 0, 1);
	DDX_Text(pDX, IDC_EDIT_HOUR, m_TempHour);
	DDV_MinMaxInt(pDX, m_TempHour, 0, 23);
	DDX_Text(pDX, IDC_EDIT_MINUTE, m_TempMinute);
	DDV_MinMaxInt(pDX, m_TempMinute, 0, 59);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSigCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CSigCtrlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ButtonSigFileChange, OnButtonSigFileChange)
	ON_BN_CLICKED(IDC_ButtonSourceFileChange, OnButtonSourceFileChange)
	ON_BN_CLICKED(IDC_ButtonSourceFileEdit, OnButtonSourceFileEdit)
	ON_BN_CLICKED(IDC_ButtonSigFileEdit, OnButtonSigFileEdit)
	ON_BN_CLICKED(IDC_BUTTON_NEW_SOURCE, OnButtonNewSource)
	ON_BN_CLICKED(IDC_BUTTON_NEW_SIG, OnButtonNewSig)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_TIMER, OnCheckTimer)
	ON_EN_UPDATE(IDC_EDIT_DAY, OnUpdateEditDay)
	ON_EN_UPDATE(IDC_EDIT_HOUR, OnUpdateEditHour)
	ON_EN_UPDATE(IDC_EDIT_MINUTE, OnUpdateEditMinute)
	ON_BN_CLICKED(IDC_CHECK_TASKBAR, OnCheckTaskbar)
	ON_COMMAND(ID_POPUP_EXIT, OnPopupExit)
	ON_COMMAND(ID_POPUP_OPEN, OnPopupOpen)
	ON_COMMAND(ID_POPUP_OPEN_REMOVE, OnPopupOpenRemove)
	ON_COMMAND(ID_POPUP_STARTUP, OnPopupStartupChange)
	ON_COMMAND(ID_POPUP_TIMED, OnPopupTimed)
	ON_COMMAND(ID_POPUP_CHANGESIGNATURE, OnPopupChangesignature)
	ON_BN_CLICKED(IDC_CHECK_STARTUPCHANGE, OnCheckStartupchange)
	ON_BN_CLICKED(IDC_CHECK_STARTUPOPEN, OnCheckStartupopen)
	ON_BN_CLICKED(IDC_CHECK_STARTUPRUN, OnCheckStartuprun)
	//}}AFX_MSG_MAP
  ON_MESSAGE(WM_ICON_NOTIFY, OnTrayNotification)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigCtrlDlg message handlers

BOOL CSigCtrlDlg::OnInitDialog()
{
  CDialog::OnInitDialog();
  
  // Add "About..." menu item to system menu.
  
  // IDM_ABOUTBOX must be in the system command range.
  ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
  ASSERT(IDM_ABOUTBOX < 0xF000);
  
  CMenu* pSysMenu = GetSystemMenu(FALSE);
  if (pSysMenu != NULL)
  {
    CString strAboutMenu;
    strAboutMenu.LoadString(IDS_ABOUTBOX);
    if (!strAboutMenu.IsEmpty())
    {
      pSysMenu->AppendMenu(MF_SEPARATOR);
      pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
    }
  }
  
  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);
  
  // Read the signature and quotes file name and path from the registry
  GetFileNames ();
  
  // Read the options from the registry
  GetOptions ();
  
  // Create taskbar handling class
  ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.Create 
    (this, WM_ICON_NOTIFY, "Signature Changer", m_hIcon, NULL);

  // Add icon to taskbar
  if (m_bTaskbarIcon)
  {
    ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.AddIcon ();
    
    // Set button text
    m_OKButtonCtrl.SetWindowText ("Close and Save");
    m_CancelButtonCtrl.SetWindowText ("Close without Saving");
  }
  else
  {
    ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.RemoveIcon ();
    
    // Set button text
    m_OKButtonCtrl.SetWindowText ("Exit and Save");
    m_CancelButtonCtrl.SetWindowText ("Exit without Saving");
  }
  
  if (m_bStartupChange) 
  {
    ChangeSignature ();
  }

  // Set the intial check states of check buttons
  m_CheckStartupChange.SetCheck (m_bStartupChange);
  m_CheckStartupOpen.SetCheck (m_bStartupOpen);
  m_CheckStartupRun.SetCheck (m_bStartupRun);
  m_CheckTaskbar.SetCheck (m_bTaskbarIcon);
  m_CheckTimer.SetCheck (m_bChangeTimer);
  OnCheckTimer ();
  
  // Set the intial numbers for the time intervals
  char temp [255];
  itoa (m_nDay, temp, 10);
  m_EditDay.SetWindowText (temp);
  itoa (m_nHour, temp, 10);
  m_EditHour.SetWindowText (temp);
  itoa (m_nMinute, temp, 10);
  m_EditMinute.SetWindowText (temp);
  
  if (m_bChangeTimer)
  { 
    UINT milli_day = m_nDay * 86400000;
    UINT milli_hour = m_nHour * 3600000;
    UINT milli_minute = m_nMinute * 60000;
    UINT milli_total = milli_day + milli_hour + milli_minute;
    if (milli_total != 0)
      SetTimer (SIGNATURE_TIMER, milli_total, NULL);
  }

  return TRUE;  // return TRUE  unless you set the focus to a control
  }

void CSigCtrlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CSigCtrlDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();

    // Remove icon from taskbar
    ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.RemoveIcon ();

    /* destroy all data in the quotes list that might have been 
       allocated earlier */
    CString *quote = NULL;
    while (! m_quote_list.IsEmpty()) {
        quote = (CString *)m_quote_list.RemoveHead ();
        delete quote;
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSigCtrlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSigCtrlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CSigCtrlDlg::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
  if (lParam == WM_LBUTTONUP || lParam == WM_RBUTTONUP)
  {
    DisplayPopup ();
    return 0;
  }
  else
  {
    // Delegate all the work back to the default implementation in CSystemTray.
    return ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.OnTrayNotification(wParam, lParam);
  }
}

BOOL CSigCtrlDlg::ShouldBeVisible ()
{
  if (!m_bStartupOpen && m_bTaskbarIcon)
  {
    return FALSE;
  }
  else
  {
    return TRUE;
  }
}

BOOL CSigCtrlDlg::GetFileNames () {
    // Read registry for variables 
    CString strSection = "FilePaths";
    CString strStringItem = "SourceFile";
    CWinApp* pApp = AfxGetApp();
    CString temp_filepath;
    CFile file;
    CFileStatus status;

    /* Get the source file path and name */
    temp_filepath = pApp->GetProfileString(strSection, strStringItem);

    /* Check for file existance */
    if ( CFile::GetStatus (temp_filepath, status) )
    { /* file exists, so check for correct file type*/
        if (ReadSourceFile (temp_filepath)) {
            UpdateSourceFileField (temp_filepath);
            m_source_filepath = temp_filepath;
            m_ButtonSourceEdit.EnableWindow (TRUE);
        }
    }

    /* Get the signature file path and name */
    strStringItem = "SigFile";
    temp_filepath = pApp->GetProfileString(strSection, strStringItem);

    /* Check for file existance */
    if ( CFile::GetStatus (temp_filepath, status) )
    {
        UpdateSigFileField (temp_filepath);
        m_sig_filepath = temp_filepath;
        m_ButtonSigEdit.EnableWindow (TRUE);
    }

	return TRUE;
}

// Saves the filenames to the registry
BOOL CSigCtrlDlg::SaveFilenames ()
{
    CString strSection       = "FilePaths";
    CString strStringItem    = "SourceFile";

    CWinApp* pApp = AfxGetApp();

    pApp->WriteProfileString(strSection, strStringItem, m_source_filepath);

    strStringItem = "SigFile";
    pApp->WriteProfileString(strSection, strStringItem, m_sig_filepath);

    return TRUE;
}

// Reads options from the registry
BOOL CSigCtrlDlg::GetOptions ()
{
    // Read registry for variables 
    CString strSection = "Options";
    CString strStringItem = "StartupChange";
    CWinApp* pApp = AfxGetApp();

    /* Get the option for whether to change the quote at program startup */
    m_bStartupChange = pApp->GetProfileInt(strSection, strStringItem, 0);

    /* Get the option for whether to startup the program at system bootup */
    strStringItem = "StartupRun";
    m_bStartupRun = pApp->GetProfileInt (strSection, strStringItem, 0);

    /* Get the option for whether to show the dialog when the app startsup */
    strStringItem = "StartupOpen";
    m_bStartupOpen = pApp->GetProfileInt (strSection, strStringItem, 0);

    /* Get the option for having an icon remain in the taskbar */
    strStringItem = "TaskbarIcon";
    m_bTaskbarIcon = pApp->GetProfileInt (strSection, strStringItem, 1);

    /* Get the option for changing the signature at specific intervals */
    strStringItem = "ChangeTimer";
    m_bChangeTimer = pApp->GetProfileInt (strSection, strStringItem, 0);

    /* Get the options for the time interval */
    strStringItem = "Day";
    m_nDay = pApp->GetProfileInt (strSection, strStringItem, 0);
    strStringItem = "Hour";
    m_nHour = pApp->GetProfileInt (strSection, strStringItem, 0);
    strStringItem = "Minute";
    m_nMinute = pApp->GetProfileInt (strSection, strStringItem, 0);

    return TRUE;
}

// Saves the options to the registry
BOOL CSigCtrlDlg::SaveOptions ()
{
    CWinApp* pApp = AfxGetApp();
    CString strSection       = "Options";
    CString strStringItem    = "StartupChange";
    pApp->WriteProfileInt (strSection, strStringItem, m_bStartupChange);

    strStringItem = "StartupRun";
    pApp->WriteProfileInt (strSection, strStringItem, m_bStartupRun);

    // make changes to registry to make this happen
    RunAtSystemStartup (m_bStartupRun);

    strStringItem = "StartupOpen";
    pApp->WriteProfileInt (strSection, strStringItem, m_bStartupOpen);

    strStringItem = "TaskbarIcon";
    pApp->WriteProfileInt (strSection, strStringItem, m_bTaskbarIcon);

    strStringItem = "ChangeTimer";
    pApp->WriteProfileInt (strSection, strStringItem, m_bChangeTimer);

    strStringItem = "Day";
    pApp->WriteProfileInt (strSection, strStringItem, m_nDay);
    strStringItem = "Hour";
    pApp->WriteProfileInt (strSection, strStringItem, m_nHour);
    strStringItem = "Minute";
    pApp->WriteProfileInt (strSection, strStringItem, m_nMinute);

    return TRUE;
}

// Alters the registry to have this application run at startup, 
// or removes it from running at startup
BOOL CSigCtrlDlg::RunAtSystemStartup (BOOL run)
{
  if (run)
  {
    CString appName = AfxGetAppName ();
    appName += ".exe";

    CString appHelpPath = ((CSigCtrlApp*)AfxGetApp())->m_pszHelpFilePath;

    int endPos = appHelpPath.ReverseFind ('\\');

    CString appPath = appHelpPath.Left (endPos + 1);

    CString appPathName = appPath + appName;

    HKEY hKey;
    LONG lRetStatus;
    DWORD dRetInfo;

    lRetStatus = RegCreateKeyEx (HKEY_CURRENT_USER,
      TEXT("Software\\Microsoft\\Windows\\CurrentVersion\\Run"),
      0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dRetInfo);
  
    if (lRetStatus != ERROR_SUCCESS)
    {
      return FALSE;
    }
  
    lRetStatus = RegSetValueEx (hKey, "Run Signature Changer", 0, REG_SZ, 
      (const unsigned char*) (LPCTSTR) appPathName, appPathName.GetLength ());

    RegCloseKey(hKey);

    if (lRetStatus != ERROR_SUCCESS)
    {
      return FALSE;
    }
  }
  else
  { 
    HKEY hKey;
    LONG lRetStatus;

    lRetStatus = RegOpenKeyEx (HKEY_CURRENT_USER,
      TEXT("Software\\Microsoft\\Windows\\CurrentVersion\\Run"),
      0, KEY_ALL_ACCESS, &hKey);
  
    if (lRetStatus != ERROR_SUCCESS)
    {
      return FALSE;
    }
  
    lRetStatus = RegDeleteValue (hKey, "Run Signature Changer");

    RegCloseKey(hKey);

    if (lRetStatus != ERROR_SUCCESS)
    {
      return FALSE;
    }
  }

  return TRUE;
}

void CSigCtrlDlg::OnOK() 
{
    /* Save filenames to registry */
    SaveFilenames ();

    /* Save option to registry */
    SaveOptions ();

    if (m_bTaskbarIcon)
    {
      ShowWindow (SW_HIDE);
    }
    else
    {
      DestroyWindow ();
    	PostQuitMessage(1);
    }
}

void CSigCtrlDlg::OnCancel() 
{
  if (m_bTaskbarIcon)
  {
    ShowWindow (SW_HIDE);
  }
  else
  {
    DestroyWindow ();
  	PostQuitMessage(0);
  }
}

void CSigCtrlDlg::DisplayPopup ()
{
  CMenu topMenu;
  topMenu.LoadMenu (IDR_MENU_TASKBAR);
  
  CMenu* popupMenu = topMenu.GetSubMenu(0);
  ASSERT(popupMenu);

  // Set checkmarks
  if (m_bChangeTimer)
  {
    popupMenu->CheckMenuItem (ID_POPUP_TIMED, MF_BYCOMMAND | MF_CHECKED );
  }
  else
  {
    popupMenu->CheckMenuItem (ID_POPUP_TIMED, MF_BYCOMMAND | MF_UNCHECKED );
  }

  if (m_bStartupChange)
  {
    popupMenu->CheckMenuItem (ID_POPUP_STARTUP, MF_BYCOMMAND | MF_CHECKED );
  }
  else
  {
    popupMenu->CheckMenuItem (ID_POPUP_STARTUP, MF_BYCOMMAND | MF_UNCHECKED );
  }

  // Display and track the popup menu
  CPoint pos;
  GetCursorPos(&pos);

  SetForegroundWindow();

  popupMenu->TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, pos.x, 
    pos.y, this);

  // BUGFIX: See "PRB: Menus for Notification Icons Don't Work Correctly"
  PostMessage(WM_NULL, 0, 0);
}

void CSigCtrlDlg::OnButtonSigFileChange() 
{
    /* Create file dialog */
    CFileDialog filedialog(TRUE, "txt", "signature.txt", 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
        "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||", NULL);

    /* Set initial directory of dialog */
    if (m_sig_filepath != "") {
        filedialog.m_ofn.lpstrInitialDir = m_sig_filepath;
    }

    /* Cause dialog to appear in modal mode */
    int returnvalue = filedialog.DoModal();
	if (returnvalue == IDOK) 
	{
        /* get the filepath that the user selected */
        CString temp_filepath = filedialog.GetPathName();

        CFile file;
        CFileStatus status;

        /* Check for file existance */
        if ( CFile::GetStatus (temp_filepath, status) )
        { /* file exists, so just use the chosen file */
            UpdateSigFileField (temp_filepath);
            m_sig_filepath = temp_filepath;
            m_ButtonSigEdit.EnableWindow (TRUE);
        } else { /* file does not exist */
            CString message = temp_filepath;
            message += "\nThis file does not exist.\n Create new file?";
            if (AfxMessageBox (message, MB_YESNO, 0) == IDYES) {
                CreateNewSigFile (temp_filepath);
                UpdateSigFileField (temp_filepath);
                m_sig_filepath = temp_filepath;
                m_ButtonSigEdit.EnableWindow (TRUE);
            } else
                return;
        }
	}
}

/* user selects a different source for signature entries */
void CSigCtrlDlg::OnButtonSourceFileChange() 
{
	CFileDialog filedialog(TRUE, "qte", "quotes.qte", 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
        "Quotation Source Files (*.qte)|*.qte|All Files (*.*)|*.*||", NULL);

    /* Set initial directory of dialog */
    if (m_source_filepath != "") {
        filedialog.m_ofn.lpstrInitialDir = m_source_filepath;
    }
    
    int returnvalue = filedialog.DoModal();
	if (returnvalue == IDOK) 
	{
        /* get the filepath that the user selected */
        CString temp_filepath = filedialog.GetPathName();

        CFile file;
        CFileStatus status;

        /* Check for file existance */
        if ( CFile::GetStatus (temp_filepath, status) )
        { /* file exists, so check for correct file type*/
            if (ReadSourceFile (temp_filepath)) {
                UpdateSourceFileField (temp_filepath);
                m_source_filepath = temp_filepath;
                m_ButtonSourceEdit.EnableWindow (TRUE);
            } else {
                AfxMessageBox ("File format is invalid.\nFile read unsuccessful.\n");  
                return;
            }
        } else { /* file does not exist */
            CString message = temp_filepath;
            message += "\nThis file does not exist.\n Create new file?";
            if (AfxMessageBox (message, MB_YESNO, 0) == IDYES) {
                CreateNewSourceFile (temp_filepath);
                UpdateSourceFileField (temp_filepath);
                m_source_filepath = temp_filepath;
                m_ButtonSourceEdit.EnableWindow (TRUE);
            } else
                return;
        }
    }	
}

void CSigCtrlDlg::OnButtonSourceFileEdit() 
{
    CDialogEditQuotes dialog;
    CString *quote = NULL;
    CString *dialog_quote = NULL;

    /* initiate the dialog's knowledge of the quotes */
    /* copy the quotes list into the dialog's quotes list */
    POSITION pos = m_quote_list.GetHeadPosition ();
    while (pos != NULL) {
        quote = (CString *)m_quote_list.GetNext(pos);
        dialog_quote = new CString;
        *dialog_quote = *quote;
        dialog.m_quote_list.AddTail (dialog_quote);
    }

    /* display edit dialog */
    if (dialog.DoModal() == IDOK) {
        /* destroy all data in the quotes list that might have been 
           allocated earlier */
        quote = NULL;
        while (! m_quote_list.IsEmpty()) {
            quote = (CString *)m_quote_list.RemoveHead ();
            delete quote;
        }

        /* copy the list contained in the dialog into the quotes list */
        POSITION pos = dialog.m_quote_list.GetHeadPosition ();
        dialog_quote = NULL;
        quote = NULL;
        while (pos != NULL) {
            dialog_quote = (CString *)dialog.m_quote_list.GetNext(pos);
            quote = new CString;
            *quote = *dialog_quote;
            m_quote_list.AddTail (quote);
        }

        /* Save quotes file */
        SaveQuotes (m_source_filepath);
    }
}

void CSigCtrlDlg::OnButtonSigFileEdit() 
{
  if (m_sig_filepath == "") 
  {
    return;
  }

  // read in signature text
  ifstream inFile (m_sig_filepath, ios::in);
  if (!inFile)
  {
    CString error = "Failed to open signature file ";
    error += m_sig_filepath;
    AfxMessageBox (error);
    return;
  }
  
  CString text;
  char tempChar;
  
  while (!inFile.eof ())
  {
    try {
      tempChar = inFile.get ();
    } catch (...) {
      inFile.close ();
      CString error = "Failure during file read for signature file ";
      error += m_sig_filepath;
      AfxMessageBox (error);
      return;
    }

    text += tempChar;
  }
  
  inFile.close ();

  if ((text.GetAt (text.GetLength () - 1)) == -1)
  {
    text = text.Left (text.GetLength () - 1);
  }

  CDialogEditFile dialog;
  dialog.m_Text = text;

  if (dialog.DoModal () == IDOK) 
  {
    ChangeSignature (dialog.m_Text);
  }
}

/* Create new source file */
void CSigCtrlDlg::OnButtonNewSource() 
{
	CFileDialog filedialog(TRUE, "qte", "quotes.qte", 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
        "Quotation Source Files (*.qte)|*.qte|All Files (*.*)|*.*||", NULL);

    /* Set initial directory of dialog */
    if (m_source_filepath != "") {
        filedialog.m_ofn.lpstrInitialDir = m_source_filepath;
    }
    
    int returnvalue = filedialog.DoModal();
	if (returnvalue == IDOK) 
	{
        /* get the filepath that the user selected */
        CString temp_filepath = filedialog.GetPathName();

        CFile file;
        CFileStatus status;

        /* Check for file existance */
        if ( CFile::GetStatus (temp_filepath, status) )
        { /* file exists, so see if user wants to overwrite */
            CString message = temp_filepath;
            message += "\nThis file already exists.\nOverwrite file?";

            if (AfxMessageBox (message, MB_YESNO, 0) == IDYES) {
                /* create new file */
                CreateNewSourceFile (temp_filepath);
                UpdateSourceFileField (temp_filepath);
                m_source_filepath = temp_filepath;
                m_ButtonSourceEdit.EnableWindow (TRUE);
            } else {
                return;
            }
        } else { /* file does not exist */
            CreateNewSourceFile (temp_filepath);
            UpdateSourceFileField (temp_filepath);
            m_source_filepath = temp_filepath;
            m_ButtonSourceEdit.EnableWindow (TRUE);
        }
    }	
}

/* Change the static text displayed for the source quotes file */
void CSigCtrlDlg::UpdateSourceFileField (CString filePath) {
    m_EditSourceFile.SetWindowText(filePath);
}

/* Change the text field for the signature file to the path 
   passed in */
void CSigCtrlDlg::UpdateSigFileField (CString filepath) {
    m_EditSigFile.SetWindowText(filepath);
}

/* Creates a new signature source material file */
BOOL CSigCtrlDlg::CreateNewSourceFile (CString filepath) {
    CFile file;
    CFileException fileException;

    /* Create and open a new file */
    if ( !file.Open (filepath, CFile::modeCreate | 
        CFile::modeReadWrite , &fileException ))
    {
        TRACE( "Can't open file %s, error = %u\n",
            filepath, fileException.m_cause );
        return FALSE;
    }

    /* Create and attach an archive object to the open file */
    CArchive ar (&file, CArchive::store);

    /* Write out initial data for a new source file */
    try {
        ar << (int) 0;
    } catch (...) {
        ar.Close ();
        file.Close ();
        return FALSE;
    }

    /* Close file and archive */
    ar.Close ();
    file.Close ();

    return TRUE;
}

/* Checks for a valid file format for the signature source material 
   file */
BOOL CSigCtrlDlg::IsValidSourceFile (CString filepath) {
    CFile file;
    CFileException fileException;

    /* Open the file */
    if ( !file.Open (filepath, CFile::modeRead, &fileException ))
    {
        TRACE( "Can't open file %s, error = %u\n",
            filepath, fileException.m_cause );
        return FALSE;
    }

    /* Create and attach an archive object to the open file */
    CArchive ar (&file, CArchive::load);

    /* Read in the number of quotes */
    int num_quotes = 0;
    try { 
        ar >> num_quotes; 
    } catch (...) {
        /* Error in reading file so close file and archive and return*/
        ar.Close ();
        file.Close ();
        return FALSE;
    }

    /* read in all the quotes */
    int count = 0;
    CString quote;

    while (count < num_quotes) {
        try {
            ar >> quote;
        } catch (...) {
            /* Error in reading file so close file and archive and return*/
            ar.Close ();
            file.Close ();
            return FALSE;
        }

        count++;
    }

    /* Close file and archive */
    ar.Close ();
    file.Close ();

    return TRUE;
}

BOOL CSigCtrlDlg::SaveQuotes (CString filepath) {
    CFile file;
    CFileException fileException;

    /* Open the file */
    if ( !file.Open (filepath, CFile::modeReadWrite , &fileException ))
    {
        TRACE( "Can't open file %s, error = %u\n",
            filepath, fileException.m_cause );
        return FALSE;
    }

    /* Create and attach an archive object to the open file */
    CArchive ar (&file, CArchive::store);

    /* Write out all the quotes to the source file */
    int count = m_quote_list.GetCount ();

    try {
        ar << count;

        POSITION pos = m_quote_list.GetHeadPosition ();
        while (pos != NULL) {
            CString *quote = (CString *)m_quote_list.GetNext(pos);
            ar << *quote;
        }
    } catch (...) {
        ar.Close ();
        file.Close ();
        return FALSE;
    }

    /* Close file and archive */
    ar.Close ();
    file.Close ();

    return TRUE;
}

/* Checks for a valid file format for the signature source material 
   file and reads it into the quotes list */
BOOL CSigCtrlDlg::ReadSourceFile (CString filepath) {
    CFile file;
    CFileException fileException;

    /* Open the file */
    if ( !file.Open (filepath, CFile::modeRead, &fileException ))
    {
        TRACE( "Can't open file %s, error = %u\n",
            filepath, fileException.m_cause );
        return FALSE;
    }

    /* Create and attach an archive object to the open file */
    CArchive ar (&file, CArchive::load);

    /* Read in the number of quotes */
    int num_quotes = 0;
    try { 
        ar >> num_quotes; 
    } catch (...) {
        /* Error in reading file so close file and archive and return*/
        ar.Close ();
        file.Close ();
        return FALSE;
    }

    /* read in all the quotes */
    int count = 0;
    CString *quote;

    while (count < num_quotes) {
        try {
            quote = new CString;
            ar >> *quote;
        } catch (...) {
            /* Error in reading file so close file and archive and return*/
            ar.Close ();
            file.Close ();
            return FALSE;
        }

        m_quote_list.AddTail (quote);
        count++;
    }

    /* Close file and archive */
    ar.Close ();
    file.Close ();

    return TRUE;
}


void CSigCtrlDlg::OnButtonNewSig() 
{
	CFileDialog filedialog(TRUE, "txt", "signature.txt", 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
        "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||", NULL);

    /* Set initial directory of dialog */
    if (m_sig_filepath != "") {
        filedialog.m_ofn.lpstrInitialDir = m_sig_filepath;
    }

	int returnvalue = filedialog.DoModal();
	if (returnvalue == IDOK) 
	{
        /* get the filepath that the user selected */
        CString temp_filepath = filedialog.GetPathName();

        CFile file;
        CFileStatus status;

        /* Check for file existance */
        if ( CFile::GetStatus (temp_filepath, status) )
        { /* file exists, so see if user wants to overwrite */
            CString message = temp_filepath;
            message += "\nThis file already exists.\nOverwrite file?";

            if (AfxMessageBox (message, MB_YESNO, 0) == IDYES) {
                /* create new file */
                CreateNewSigFile (temp_filepath);
                UpdateSigFileField (temp_filepath);
                m_sig_filepath = temp_filepath;
                m_ButtonSigEdit.EnableWindow (TRUE);
            } else {
                return;
            }
        } else { /* file does not exist */
            CreateNewSigFile (temp_filepath);
            UpdateSigFileField (temp_filepath);
            m_sig_filepath = temp_filepath;
            m_ButtonSigEdit.EnableWindow (TRUE);
        }
    }	
}

/* Creates a new signature file */
BOOL CSigCtrlDlg::CreateNewSigFile (CString filepath) {
    CFile file;
    CFileException fileException;

    /* Create and open a new file */
    if ( !file.Open (filepath, CFile::modeCreate | 
        CFile::modeReadWrite, &fileException ))
    {
        TRACE( "Can't open file %s, error = %u\n",
            filepath, fileException.m_cause );
        return FALSE;
    }

    /* Close file */
    file.Close ();

    return TRUE;
}

// Change the signature in the signature file to a random quote
BOOL CSigCtrlDlg::ChangeSignature () 
{
  if (m_sig_filepath == "" || m_source_filepath == "") 
  {
    return FALSE;
  }
  
  int num = m_quote_list.GetCount ();
  if (num > 0) 
  {
    // randomly choose a quote to put into the signature file
    // Seed the random-number generator with current time so that
    // the numbers will be different every time we run.
    srand( (unsigned)time( NULL ) );
    int quote = rand () % num;
    CString *quote_str = 
      (CString *)m_quote_list.GetAt(m_quote_list.FindIndex (quote));
    
    return (ChangeSignature (*quote_str));
  } 
  else 
  {
    return FALSE;
  }
  
  return TRUE;
}

// Changes the signature in the signature file to the specified text
BOOL CSigCtrlDlg::ChangeSignature (CString newSignature)
{
  if (m_sig_filepath == "" || m_source_filepath == "") 
  {
    return FALSE;
  }
      
  // write out quote to signature
  ofstream outFile (m_sig_filepath, ios::out);
  if (!outFile) 
  {
    CString error = "Failed to open output file ";
    error += m_sig_filepath;
    AfxMessageBox (error);
    return FALSE;
  }
  outFile << newSignature;
  
  outFile.close ();

  return TRUE;
}

void CSigCtrlDlg::OnTimer(UINT nIDEvent) 
{
    if (SIGNATURE_TIMER	== nIDEvent)
    {
        ChangeSignature ();
        
        // Reset timer
        UINT milli_day = m_nDay * 86400000;
        UINT milli_hour = m_nHour * 3600000;
        UINT milli_minute = m_nMinute * 60000;
        UINT milli_total = milli_day + milli_hour + milli_minute;
        if (milli_total != 0)
            SetTimer (SIGNATURE_TIMER, milli_total, NULL);
    }

	CDialog::OnTimer(nIDEvent);
}

void CSigCtrlDlg::OnCheckTimer() 
{
    /* Enable or disable date entry boxes depending on value
       of check box */
    if ( m_CheckTimer.GetCheck ())
    {
        m_EditDay.EnableWindow (TRUE);
        m_EditHour.EnableWindow (TRUE);
        m_EditMinute.EnableWindow (TRUE);
        m_StaticDay.EnableWindow (TRUE);
        m_StaticHour.EnableWindow (TRUE);
        m_StaticMinute.EnableWindow (TRUE);

        // Set timer
        UINT milli_day = m_nDay * 86400000;
        UINT milli_hour = m_nHour * 3600000;
        UINT milli_minute = m_nMinute * 60000;
        UINT milli_total = milli_day + milli_hour + milli_minute;
        if (milli_total != 0)
            SetTimer (SIGNATURE_TIMER, milli_total, NULL);

        // Save option to variable
        m_bChangeTimer = TRUE;
    } else {
        m_EditDay.EnableWindow (FALSE);
        m_EditHour.EnableWindow (FALSE);
        m_EditMinute.EnableWindow (FALSE);
        m_StaticDay.EnableWindow (FALSE);
        m_StaticHour.EnableWindow (FALSE);
        m_StaticMinute.EnableWindow (FALSE);

        // Stop timer
        KillTimer (SIGNATURE_TIMER);

        // Save option to variable
        m_bChangeTimer = FALSE;
    }
}

void CSigCtrlDlg::OnUpdateEditDay() 
{
    // Stop timer
    KillTimer (SIGNATURE_TIMER);

    // Update variable
    CString temp;
    m_EditDay.GetWindowText (temp);
    m_nDay = atoi (temp);

    // Start timer
    UINT milli_day = m_nDay * 86400000;
    UINT milli_hour = m_nHour * 3600000;
    UINT milli_minute = m_nMinute * 60000;
    UINT milli_total = milli_day + milli_hour + milli_minute;
    if (milli_total != 0)
        SetTimer (SIGNATURE_TIMER, milli_total, NULL);
}

void CSigCtrlDlg::OnUpdateEditHour() 
{
    // Stop timer
    KillTimer (SIGNATURE_TIMER);

    // Update variable
    CString temp;
    m_EditHour.GetWindowText (temp);
    m_nHour = atoi (temp);

    // Start timer
    UINT milli_day = m_nDay * 86400000;
    UINT milli_hour = m_nHour * 3600000;
    UINT milli_minute = m_nMinute * 60000;
    UINT milli_total = milli_day + milli_hour + milli_minute;
    if (milli_total != 0)
        SetTimer (SIGNATURE_TIMER, milli_total, NULL);	
}

void CSigCtrlDlg::OnUpdateEditMinute() 
{
    // Stop timer
    KillTimer (SIGNATURE_TIMER);

    // Update variable
    CString temp;
    m_EditMinute.GetWindowText (temp);
    m_nMinute = atoi (temp);

    // Start timer
    UINT milli_day = m_nDay * 86400000;
    UINT milli_hour = m_nHour * 3600000;
    UINT milli_minute = m_nMinute * 60000;
    UINT milli_total = milli_day + milli_hour + milli_minute;
    if (milli_total != 0)
        SetTimer (SIGNATURE_TIMER, milli_total, NULL);	
}

void CSigCtrlDlg::OnCheckStartupchange() 
{
  if ( m_CheckStartupChange.GetCheck ())
    m_bStartupChange = TRUE;
  else
    m_bStartupChange = FALSE;
}

void CSigCtrlDlg::OnCheckStartupopen() 
{
  if ( m_CheckStartupOpen.GetCheck ())
    m_bStartupOpen = TRUE;
  else
    m_bStartupOpen = FALSE;
}

void CSigCtrlDlg::OnCheckStartuprun() 
{
  if ( m_CheckStartupRun.GetCheck ())
  {
    m_bStartupRun = TRUE;
  }
  else
  {
    m_bStartupRun = FALSE;
  }
}

void CSigCtrlDlg::OnCheckTaskbar() 
{
  if ( m_CheckTaskbar.GetCheck ())
  {
    m_bTaskbarIcon = TRUE;
    
    // Add icon to taskbar
    ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.AddIcon ();
    
    // Change button text
    m_OKButtonCtrl.SetWindowText ("Close and Save");
    m_CancelButtonCtrl.SetWindowText ("Close without Saving");
  }
  else
  {
    m_bTaskbarIcon = FALSE;
    
    // Remove icon from taskbar
    ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.RemoveIcon ();
    
    // Change button text
    m_OKButtonCtrl.SetWindowText ("Exit and Save");
    m_CancelButtonCtrl.SetWindowText ("Exit without Saving");
  }
}

void CSigCtrlDlg::OnPopupExit() 
{
  DestroyWindow ();
  PostQuitMessage (0);
}

void CSigCtrlDlg::OnPopupOpen() 
{
  ShowWindow (SW_SHOW);
}

void CSigCtrlDlg::OnPopupOpenRemove() 
{
  ShowWindow (SW_SHOW);

  m_bTaskbarIcon = FALSE;
  m_CheckTaskbar.SetCheck (0);
  
  // Remove icon from taskbar
  ((CSigCtrlApp*)AfxGetApp())->m_TrayIcon.RemoveIcon ();
  
  // Change button text
  m_OKButtonCtrl.SetWindowText ("Exit and Save");
  m_CancelButtonCtrl.SetWindowText ("Exit without Saving");
}

void CSigCtrlDlg::OnPopupStartupChange() 
{
  if (m_bStartupChange)
  {
    m_bStartupChange = FALSE;
  }
  else
  {
    m_bStartupChange = TRUE;
  }

  m_CheckStartupChange.SetCheck (m_bStartupChange);
  OnCheckStartupchange ();
}

void CSigCtrlDlg::OnPopupTimed() 
{
  if (m_bChangeTimer)
  {
    m_bChangeTimer = FALSE;
  }
  else
  {
    m_bChangeTimer = TRUE;
  }

  m_CheckTimer.SetCheck (m_bChangeTimer);
  OnCheckTimer ();
}

void CSigCtrlDlg::OnPopupChangesignature() 
{
  if (!ChangeSignature ())
  {
    AfxMessageBox ("Unable to change signature");
  }
}
