// SigCtrlDlg.h : header file
//

#if !defined(AFX_SIGCTRLDLG_H__8FC77C6A_8D28_11D3_946D_444553540001__INCLUDED_)
#define AFX_SIGCTRLDLG_H__8FC77C6A_8D28_11D3_946D_444553540001__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CSigCtrlDlg dialog

#define SIGNATURE_TIMER 1

#define WM_ICON_NOTIFY  WM_APP+10

class CSigCtrlDlg : public CDialog
{
  // Construction
public:
  CSigCtrlDlg(CWnd* pParent = NULL);	// standard constructor
   
  // Access Functions
  BOOL ShouldBeVisible ();

  // Dialog Data
  //{{AFX_DATA(CSigCtrlDlg)
	enum { IDD = IDD_SIGCTRL_DIALOG };
	CButton	m_ButtonSigEdit;
	CButton	m_CheckStartupRun;
	CButton	m_CheckStartupOpen;
	CButton	m_CheckStartupChange;
  CButton	m_CancelButtonCtrl;
  CButton	m_OKButtonCtrl;
  CButton	m_CheckTimer;
  CButton	m_CheckTaskbar;
  CStatic	m_StaticMinute;
  CStatic	m_StaticHour;
  CStatic	m_StaticDay;
  CEdit	m_EditMinute;
  CEdit	m_EditHour;
  CEdit	m_EditDay;
  CEdit	m_EditSourceFile;
  CEdit	m_EditSigFile;
  CButton	m_ButtonSourceEdit;
  int		m_TempDay;
  int		m_TempHour;
  int		m_TempMinute;
	//}}AFX_DATA
  
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CSigCtrlDlg)
	protected:
  virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
  
  // Implementation
protected:
  HICON m_hIcon;
  CString m_sig_filepath;
  CString m_source_filepath;
  CPtrList m_quote_list;
  BOOL m_bStartupChange;
  BOOL m_bStartupOpen;
  BOOL m_bStartupRun;
  BOOL m_bTaskbarIcon;
  BOOL m_bChangeTimer;
  int m_nDay;
  int m_nMinute;
  int m_nHour;
  
  // Generated message map functions
  //{{AFX_MSG(CSigCtrlDlg)
  virtual BOOL OnInitDialog();
  afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
  afx_msg void OnDestroy();
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnButtonSigFileChange();
  afx_msg void OnButtonSourceFileChange();
  afx_msg void OnButtonSourceFileEdit();
  afx_msg void OnButtonSigFileEdit();
  afx_msg void OnButtonNewSource();
  afx_msg void OnButtonNewSig();
  virtual void OnOK();
  afx_msg void OnTimer(UINT nIDEvent);
  afx_msg void OnCheckTimer();
  afx_msg void OnUpdateEditDay();
  afx_msg void OnUpdateEditHour();
  afx_msg void OnUpdateEditMinute();
  afx_msg void OnCheckTaskbar();
  virtual void OnCancel();
	afx_msg void OnPopupExit();
	afx_msg void OnPopupOpen();
	afx_msg void OnPopupOpenRemove();
	afx_msg void OnPopupStartupChange();
	afx_msg void OnPopupTimed();
	afx_msg void OnPopupChangesignature();
	afx_msg void OnCheckStartupchange();
	afx_msg void OnCheckStartupopen();
	afx_msg void OnCheckStartuprun();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
  
  // Called when action occurs with the icon in the taskbar
  LRESULT OnTrayNotification(WPARAM wParam, LPARAM lParam);

  // Alters the registry to have this application run at startup, 
  // or removes it from running at startup
  BOOL RunAtSystemStartup (BOOL run);

  // Reads the the source file path and name and 
  // the signature file path and name from the registry
  BOOL GetFileNames ();
  
  // Reads options from the registry
  BOOL GetOptions ();
  
  // Saves the filenames to the registry
  BOOL SaveFilenames ();
  
  // Saves the options to the registry
  BOOL SaveOptions ();
  
  /* Creates a new signature file */
  BOOL CreateNewSigFile (CString filepath);
  
  /* Creates a new signature source material file */
  BOOL CreateNewSourceFile (CString filepath);
  
  /* Change the text field for the signature source material to the 
  path passed in */
  void UpdateSourceFileField (CString filepath);
  
  /* Change the text field for the signature file to the path 
  passed in */
  void UpdateSigFileField (CString filepath);
  
  /* Checks for a valid file format for the signature source material 
  file */
  BOOL IsValidSourceFile (CString filepath);
  
  /* Saves quotes to the signature source file */
  BOOL SaveQuotes (CString filepath);
  
  /* Checks for a valid file format for the signature source material 
  file and reads it into the quotes list */
  BOOL ReadSourceFile (CString filepath);
  
  // Change the signature in the signature file to a random quote
  BOOL ChangeSignature();

  // Changes the signature in the signature file to the specified text
  BOOL ChangeSignature (CString newSignature);

  // Displays the popup menu that appears in the icon tray after a mouse click there
  void DisplayPopup ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SIGCTRLDLG_H__8FC77C6A_8D28_11D3_946D_444553540001__INCLUDED_)
